"use strict";

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");
var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.useMultiSelect = exports.MultiSelectProvider = void 0;
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _react = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof _WeakMap) return null; var r = new _WeakMap(), t = new _WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? _Object$getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? _Object$defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const defaultStrings = {
  allItemsAreSelected: 'All items are selected.',
  clearSearch: 'Clear Search',
  clearSelected: 'Clear Selected',
  noOptions: 'No options',
  search: 'Search',
  selectAll: 'Select All',
  selectAllFiltered: 'Select All (Filtered)',
  selectSomeItems: 'Select...',
  create: 'Create'
};
const defaultProps = {
  value: [],
  hasSelectAll: true,
  debounceDuration: 200,
  options: []
};
const MultiSelectContext = /*#__PURE__*/_react.default.createContext({});
const MultiSelectProvider = _ref => {
  let {
    props,
    children
  } = _ref;
  const [options, setOptions] = (0, _react.useState)(props.options);
  const t = key => {
    var _a;
    return ((_a = props.overrideStrings) === null || _a === void 0 ? void 0 : _a[key]) || defaultStrings[key];
  };
  (0, _react.useEffect)(() => {
    setOptions(props.options);
  }, [props.options]);
  return (0, _jsxRuntime.jsx)(MultiSelectContext.Provider, (0, _assign.default)({
    value: (0, _assign.default)((0, _assign.default)((0, _assign.default)({
      t
    }, defaultProps), props), {
      options,
      setOptions
    })
  }, {
    children: children
  }));
};
exports.MultiSelectProvider = MultiSelectProvider;
const useMultiSelect = () => _react.default.useContext(MultiSelectContext);
exports.useMultiSelect = useMultiSelect;