"use strict";

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");
var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));
var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _react = require("react");
var Styled = _interopRequireWildcard(require("../MultiSelect.styled"));
var _MultiSelect2 = require("../MultiSelect.hooks");
var _MultiSelect3 = require("../MultiSelect.constants");
var _MultiSelect4 = require("../MultiSelect.utils");
var _MultiSelect5 = require("../MultiSelect.icons");
var _selectItem = _interopRequireDefault(require("../selectItem"));
var _selectList = _interopRequireDefault(require("../selectList"));
var _hooks = require("../../@hooks");
var _utils = require("../../@utils");
function _getRequireWildcardCache(e) { if ("function" != typeof _WeakMap) return null; var r = new _WeakMap(), t = new _WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? _Object$getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? _Object$defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = _promise.default))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

/**
 * This component represents the entire panel which gets dropped down when the
 * user selects the component.  It encapsulates the search filter, the
 * Select-all item, and the list of options.
 */

var FocusType;
(function (FocusType) {
  FocusType[FocusType["SEARCH"] = 0] = "SEARCH";
  FocusType[FocusType["NONE"] = -1] = "NONE";
})(FocusType || (FocusType = {}));
const SelectPanel = () => {
  const {
    t,
    onChange,
    options,
    setOptions,
    value,
    filterOptions: customFilterOptions,
    ItemRenderer,
    disabled,
    disableSearch,
    hasSelectAll,
    ClearIcon,
    debounceDuration,
    isCreatable,
    onCreateOption,
    isCheckboxShowing,
    closeOnChangedValue
  } = (0, _MultiSelect2.useMultiSelect)();
  const listRef = (0, _react.useRef)();
  const searchInputRef = (0, _react.useRef)();
  const [searchText, setSearchText] = (0, _react.useState)('');
  const [filteredOptions, setFilteredOptions] = (0, _react.useState)(options);
  const [searchTextForFilter, setSearchTextForFilter] = (0, _react.useState)('');
  const [focusIndex, setFocusIndex] = (0, _react.useState)(0);
  const debouncedSearch = (0, _react.useCallback)((0, _utils.debounce)(query => setSearchTextForFilter(query), debounceDuration), []);
  const skipIndex = (0, _react.useMemo)(() => {
    let start = 0;
    if (!disableSearch) start += 1; // if search is enabled then +1 to skipIndex
    if (hasSelectAll) start += 1; // if select-all is enabled then +1 to skipIndex
    return start;
  }, [disableSearch, hasSelectAll]);
  const selectAllOption = {
    label: searchText ? t('selectAllFiltered') : t('selectAll'),
    value: ''
  };
  const selectAllValues = checked => {
    var _context;
    const filteredValues = (0, _map.default)(_context = (0, _filter.default)(filteredOptions).call(filteredOptions, o => !o.disabled)).call(_context, o => o.value);
    if (checked) {
      var _context2;
      const selectedValues = (0, _map.default)(value).call(value, o => o.value);
      const finalSelectedValues = [...selectedValues, ...filteredValues];
      return (0, _filter.default)(_context2 = customFilterOptions ? filteredOptions : options).call(_context2, o => (0, _includes.default)(finalSelectedValues).call(finalSelectedValues, o.value));
    }
    return (0, _filter.default)(value).call(value, o => !(0, _includes.default)(filteredValues).call(filteredValues, o.value));
  };
  const selectAllChanged = checked => {
    const newOptions = selectAllValues(checked);
    onChange(newOptions);
  };
  const handleSearchChange = e => {
    debouncedSearch(e.target.value);
    setSearchText(e.target.value);
    setFocusIndex(FocusType.SEARCH);
  };
  const handleClear = () => {
    var _a;
    setSearchTextForFilter('');
    setSearchText('');
    (_a = searchInputRef === null || searchInputRef === void 0 ? void 0 : searchInputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
  };
  const handleItemClicked = index => {
    setFocusIndex(index);
  };
  // Arrow Key Navigation
  const handleKeyDown = e => {
    switch (e.code) {
      case _MultiSelect3.KEY.ARROW_UP:
        updateFocus(-1);
        break;
      case _MultiSelect3.KEY.ARROW_DOWN:
        updateFocus(1);
        break;
      default:
        return;
    }
    e.stopPropagation();
    e.preventDefault();
  };
  (0, _hooks.useKey)([_MultiSelect3.KEY.ARROW_DOWN, _MultiSelect3.KEY.ARROW_UP], handleKeyDown, {
    target: listRef
  });
  const handleSearchFocus = () => {
    setFocusIndex(FocusType.SEARCH);
  };
  const handleOnCreateOption = () => __awaiter(void 0, void 0, void 0, function* () {
    let newOption = {
      label: searchText,
      value: searchText,
      __isNew__: true
    };
    // if custom `onCreateOption` is given then this will call this
    if (onCreateOption) {
      newOption = yield onCreateOption(searchText);
    }
    // adds created value to existing options
    setOptions([newOption, ...options]);
    handleClear();
    onChange([...value, newOption]);
  });
  const getFilteredOptions = () => __awaiter(void 0, void 0, void 0, function* () {
    return customFilterOptions ? yield customFilterOptions(options, searchTextForFilter) : (0, _MultiSelect4.simpleFilterOptions)(options, searchTextForFilter);
  });
  const updateFocus = offset => {
    let newFocus = focusIndex + offset;
    newFocus = Math.max(0, newFocus);
    newFocus = Math.min(newFocus, options.length + Math.max(skipIndex - 1, 0));
    setFocusIndex(newFocus);
  };
  (0, _react.useEffect)(() => {
    var _a, _b;
    (_b = (_a = listRef === null || listRef === void 0 ? void 0 : listRef.current) === null || _a === void 0 ? void 0 : _a.querySelector(`[tabIndex='${focusIndex}']`)) === null || _b === void 0 ? void 0 : _b.focus();
  }, [focusIndex]);
  const [isAllOptionSelected, hasSelectableOptions] = (0, _react.useMemo)(() => {
    const filteredOptionsList = (0, _filter.default)(filteredOptions).call(filteredOptions, o => !o.disabled);
    return [(0, _every.default)(filteredOptionsList).call(filteredOptionsList, o => (0, _findIndex.default)(value).call(value, v => v.value === o.value) !== -1), filteredOptionsList.length !== 0];
    // eslint-disable-next-line
  }, [filteredOptions, value]);
  (0, _react.useEffect)(() => {
    getFilteredOptions().then(setFilteredOptions);
  }, [searchTextForFilter, options]);
  const creationRef = (0, _react.useRef)();
  (0, _hooks.useKey)([_MultiSelect3.KEY.ENTER], handleOnCreateOption, {
    target: creationRef
  });
  const showCreatable = isCreatable && searchText && !(0, _some.default)(filteredOptions).call(filteredOptions, e => (e === null || e === void 0 ? void 0 : e.value) === searchText);
  return (0, _jsxRuntime.jsxs)(Styled.SelectPanelWrapper, (0, _assign.default)({
    role: "listbox",
    ref: listRef
  }, {
    children: [!disableSearch && (0, _jsxRuntime.jsxs)(Styled.SearchArea, {
      children: [(0, _jsxRuntime.jsx)("input", {
        placeholder: t('search'),
        type: "text",
        "aria-describedby": t('search'),
        onChange: handleSearchChange,
        onFocus: handleSearchFocus,
        value: searchText,
        ref: searchInputRef,
        tabIndex: 0
      }), (0, _jsxRuntime.jsx)("button", (0, _assign.default)({
        type: "button",
        hidden: !searchText,
        onClick: handleClear,
        "aria-label": t('clearSearch')
      }, {
        children: ClearIcon || (0, _jsxRuntime.jsx)(_MultiSelect5.CrossIcon, {})
      }))]
    }), (0, _jsxRuntime.jsxs)(Styled.OptionsArea, {
      children: [hasSelectAll && hasSelectableOptions && (0, _jsxRuntime.jsx)(_selectItem.default, {
        tabIndex: skipIndex === 1 ? 0 : 1,
        checked: isAllOptionSelected,
        option: selectAllOption,
        onSelectionChanged: selectAllChanged,
        onClick: () => handleItemClicked(1),
        itemRenderer: ItemRenderer,
        disabled: disabled,
        isCheckboxShowing: isCheckboxShowing
      }), filteredOptions.length ? (0, _jsxRuntime.jsx)(_selectList.default, {
        isCheckboxShowing: isCheckboxShowing,
        skipIndex: skipIndex,
        options: filteredOptions,
        onClick: (_e, index) => handleItemClicked(index),
        closeOnChangedValue: closeOnChangedValue
      }) : showCreatable ? (0, _jsxRuntime.jsx)(Styled.SelectItemWrapper, (0, _assign.default)({
        onClick: handleOnCreateOption,
        tabIndex: 1,
        ref: creationRef
      }, {
        children: `${t('create')} "${searchText}"`
      })) : (0, _jsxRuntime.jsx)(Styled.NoOptionsItem, {
        children: t('noOptions')
      })]
    })]
  }));
};
var _default = exports.default = SelectPanel;