import _everyInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/every";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
// code borrowed from https://github.com/reach/reach-ui
// problem described https://github.com/facebook/react/issues/13029
import { useMemo } from 'react';
// eslint-disable-next-line @typescript-eslint/no-explicit-any
export function useForkedRef() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }
  return useMemo(() => {
    if (_everyInstanceProperty(refs).call(refs, ref => ref == null)) {
      return null;
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return node => {
      _forEachInstanceProperty(refs).call(refs, ref => {
        assignRef(ref, node);
      });
    };
  }, refs);
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
export function assignRef(ref,
// eslint-disable-next-line @typescript-eslint/no-explicit-any
value) {
  if (ref == null) return;
  if (isFunction(ref)) {
    ref(value);
  } else {
    try {
      ref.current = value;
    } catch (error) {
      throw new Error(`Cannot assign value "${value}" to ref "${ref}"`);
    }
  }
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/ban-types
export function isFunction(value) {
  return !!(value && {}.toString.call(value) == '[object Function]');
}