import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "@emotion/react/jsx-runtime";
import { useEffect, useRef, useState } from 'react';
import * as Styled from './Dropdown.styled';
const DropdownItems = _ref => {
  var _context;
  let {
    data,
    style,
    onChange,
    onClose
  } = _ref;
  const Component = data.href ? 'a' : 'button';
  const hrefProps = Component === 'a' && {
    href: data.href,
    target: data.target
  };
  const [isShownSubMenu, setToggleSubMenu] = useState(false);
  const ref = useRef(null);
  const handleClickEvent = {
    toggleSubMenu: data => event => {
      if (!data.submenu || data.submenu && data.submenu.length === 0) {
        onChange && onChange(event.target.textContent, data);
        onClose && onClose();
        data.onClick && data.onClick();
      }
      setToggleSubMenu(!isShownSubMenu);
    },
    selectMenu: data => event => {
      onChange && onChange(event.target.textContent, data);
      onClose && onClose();
    },
    closeSubMenu: event => {
      if (ref.current && !ref.current.contains(event.target)) {
        setToggleSubMenu(false);
      }
    }
  };
  useEffect(() => {
    document.addEventListener('click', handleClickEvent.closeSubMenu);
    return () => {
      document.removeEventListener('click', handleClickEvent.closeSubMenu);
    };
  }, []);
  return _jsxs(Styled.DropdownMenuItemWrapper, _Object$assign({
    style: style,
    ref: ref
  }, {
    children: [_jsxs(Component, _Object$assign({}, hrefProps, {
      type: "button",
      "aria-haspopup": "menu",
      "aria-expanded": "false",
      onClick: handleClickEvent.toggleSubMenu(data)
    }, {
      children: [_jsx("span", {
        children: data.title
      }), data.submenu && _jsx("svg", _Object$assign({
        xmlns: "http://www.w3.org/2000/svg",
        width: "13",
        height: "8",
        viewBox: "0 0 13 8",
        fill: "none",
        className: "right-arrow"
      }, {
        children: _jsx("path", {
          d: "M1.06348 1.04015L6.98625 5.95435L12.3167 1.04015",
          stroke: "#616166",
          strokeWidth: "2"
        })
      }))]
    })), isShownSubMenu && data.submenu && data.submenu.length !== 0 && _jsx(Styled.DropdownArea, _Object$assign({
      className: "dropdown-submenu"
    }, {
      children: _mapInstanceProperty(_context = data.submenu).call(_context, (item, index) => {
        return _jsx(Styled.DropdownMenuItems, {
          children: _jsx("button", _Object$assign({
            type: "button",
            "aria-haspopup": "menu",
            "aria-expanded": "false",
            onClick: handleClickEvent.selectMenu(item)
          }, {
            children: _jsx("span", {
              children: item.title
            })
          }))
        }, index.toString());
      })
    }))]
  }));
};
const DropdownMenu = _ref2 => {
  let {
    selectedValue = '전체',
    data,
    cx,
    onChange,
    children
  } = _ref2;
  const [isShownDropdown, setToggleDropdown] = useState(false);
  const ref = useRef(null);
  const handleClickEvent = {
    toggleDropdown: () => setToggleDropdown(!isShownDropdown),
    closeDropdown: event => {
      if (ref.current && !ref.current.contains(event.target)) {
        setToggleDropdown(false);
      }
    },
    closeDropdownAction: () => {
      setToggleDropdown(false);
    }
  };
  useEffect(() => {
    document.addEventListener('click', handleClickEvent.closeDropdown);
    return () => {
      document.removeEventListener('click', handleClickEvent.closeDropdown);
    };
  }, []);
  return _jsx(Styled.DropdownWrapper, _Object$assign({
    ref: ref,
    css: cx
  }, {
    children: _jsx(Styled.DropdownMenus, {
      children: _jsxs(Styled.DropdownArea, {
        children: [_jsxs(Styled.DropdownMenuButton, _Object$assign({
          type: "button",
          "aria-haspopup": "menu",
          "aria-expanded": "false",
          onClick: handleClickEvent.toggleDropdown
        }, {
          children: [_jsx(Styled.DropdownMenuTitle, {
            children: selectedValue
          }), _jsx("svg", _Object$assign({
            width: "16",
            height: "16",
            viewBox: "0 0 16 16",
            fill: "none",
            xmlns: "http://www.w3.org/2000/svg"
          }, {
            children: _jsx("path", {
              d: "M11.5 6L8 10L4.5 6",
              stroke: "#424242",
              strokeWidth: "1.5",
              strokeLinecap: "square",
              strokeLinejoin: "round"
            })
          }))]
        })), data && data.length !== 0 && isShownDropdown && _jsxs(Styled.DropdownMenuItems, {
          children: [children && _jsxs(_Fragment, {
            children: [_jsx(Styled.DropdownMenuItemWrapper, _Object$assign({
              "$hasChildren": true
            }, {
              children: children
            })), _jsx(Styled.Divider, {})]
          }), _mapInstanceProperty(data).call(data, (item, index) => {
            return _jsx(DropdownItems, {
              data: item,
              onChange: onChange,
              onClose: handleClickEvent.closeDropdownAction,
              onClick: item.onClick
            }, index.toString());
          })]
        })]
      })
    })
  }));
};
export default DropdownMenu;