import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _reverseInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reverse";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { useCallback, useEffect, useRef, useState } from 'react';
import * as Styled from './Dropdown.styled';
import * as Icon from './Dropdown.icon';
const DropdownList = _ref => {
  let {
    isTop,
    searchable,
    itemSelect,
    list,
    selectedItem,
    keyword
  } = _ref;
  let tempList = [...list];
  if (keyword.length) {
    tempList = _filterInstanceProperty(list).call(list, item => {
      var _context;
      return _includesInstanceProperty(_context = item.label.toLowerCase()).call(_context, keyword.toLowerCase());
    });
  }
  if (tempList.length) {
    var _context2;
    const listItem = isTop ? _reverseInstanceProperty(_context2 = _sliceInstanceProperty(tempList).call(tempList)).call(_context2) : tempList;
    return _jsx(_Fragment, {
      children: _mapInstanceProperty(listItem).call(listItem, item => _jsx(Styled.DropdownListItem, _Object$assign({
        type: "button",
        onClick: () => itemSelect(item),
        "$isSelected": item.value === selectedItem.value
      }, {
        children: item.label
      }), item.value))
    });
  }
  if (searchable) {
    return _jsx("div", _Object$assign({
      className: "dd-list-item no-result"
    }, {
      children: searchable[1]
    }));
  }
  return _jsx(_Fragment, {});
};
const Dropdown = _ref2 => {
  let {
    width = '100%',
    onChange = e => console.log(e),
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    onClickOpen = () => {},
    title = '선택해주세요',
    list = [],
    searchable,
    selected = {
      value: '',
      label: ''
    },
    isTop = false,
    size = 'small',
    arrowUpIcon,
    arrowDownIcon
  } = _ref2;
  const [isListOpen, setListOpen] = useState(false);
  const [selectedItem, setSelectedItem] = useState(selected);
  const [keyword, setKeyword] = useState('');
  const dropdownRef = useRef(null);
  // const searchFieldRef = useRef<HTMLInputElement>(null);
  const close = () => setListOpen(false);
  const handleClick = useCallback(e => {
    if (dropdownRef.current && !dropdownRef.current.contains(e.target)) {
      close();
    }
  }, []);
  useEffect(() => {
    document.addEventListener('click', handleClick);
    return () => {
      document.removeEventListener('click', handleClick);
    };
  }, [handleClick]);
  const itemSelect = _ref3 => {
    let {
      value,
      label
    } = _ref3;
    setSelectedItem({
      value,
      label
    });
    setListOpen(false);
    if (selectedItem.value !== value) onChange({
      value,
      label
    });
  };
  const toggleList = () => {
    if (!isListOpen) {
      onClickOpen();
    }
    setListOpen(!isListOpen);
    setKeyword('');
  };
  const filterList = event => {
    setKeyword(event.target.value.toLowerCase());
  };
  return _jsxs(Styled.DSDropdownWrapper, _Object$assign({
    ref: dropdownRef,
    onClick: toggleList,
    "$size": size,
    "$width": width,
    "$isOpen": isListOpen,
    "$isTop": isTop
  }, {
    children: [_jsxs(Styled.DropdownButton, _Object$assign({
      type: "button"
    }, {
      children: [_jsx(Styled.DropdownTitle, {
        children: selectedItem.label || title
      }), isTop ? _jsx("div", {
        children: arrowUpIcon || _jsx(Icon.UpArrow, {})
      }) : _jsx("div", {
        children: arrowDownIcon || _jsx(Icon.DownArrow, {})
      })]
    })), isListOpen && _jsxs(Styled.DropdownList, _Object$assign({
      "$isTop": isTop
    }, {
      children: [searchable && _jsx(Styled.DropdownListSearchBar
      // ref={searchFieldRef}
      , {
        // ref={searchFieldRef}
        placeholder: searchable[0],
        onClick: e => e.stopPropagation(),
        onChange: filterList
      }), _jsx(Styled.DropdownScrollList, {
        children: _jsx(DropdownList, {
          isTop: isTop,
          itemSelect: itemSelect,
          searchable: searchable,
          selectedItem: selectedItem,
          list: list,
          keyword: keyword
        })
      })]
    }))]
  }));
};
export default Dropdown;