import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "@emotion/react/jsx-runtime";
import React from 'react';
import * as Styled from './Textarea.styled';
import { CharLimit } from '../CharLimit';
import { Asterisk } from '../../Asterisk';
import { HelperText } from '../../HelperText';
const Textarea = /*#__PURE__*/React.forwardRef((_a, ref) => {
  var {
      width = '100%',
      label = '',
      description = '',
      placeholder = '',
      helperText = '',
      errorText = '',
      charLimit = 0,
      mustInput = false,
      hasScrollBar = true,
      isError = false,
      defaultValue = '',
      disabled = false,
      onBlur,
      onChange,
      onFocus,
      applyMaxLength = false
    } = _a,
    rest = __rest(_a, ["width", "label", "description", "placeholder", "helperText", "errorText", "charLimit", "mustInput", "hasScrollBar", "isError", "defaultValue", "disabled", "onBlur", "onChange", "onFocus", "applyMaxLength"]);
  const [, setFocus] = React.useState(false);
  const [inputValue, setInputValue] = React.useState(defaultValue);
  const length = inputValue.length || 0;
  const hasError = isError || !!(charLimit && length > charLimit);
  const hasFooterText = !!helperText || hasError && !!errorText;
  if (applyMaxLength) rest = _Object$assign(_Object$assign({}, rest), {
    maxLength: charLimit
  });
  const handleChange = event => {
    setInputValue(event.target.value);
    if (!disabled && typeof onChange === 'function') onChange(event);
  };
  const handleFocus = event => {
    if (!disabled) {
      if (typeof onFocus === 'function') onFocus(event);
      setFocus(true);
    }
  };
  const handleBlur = event => {
    if (!disabled) {
      if (typeof onBlur === 'function') onBlur(event);
      setFocus(false);
    }
  };
  return _jsxs(Styled.DSTextareaWrapper, _Object$assign({
    "$width": width
  }, {
    children: [(label || charLimit || description) && _jsxs(_Fragment, {
      children: [_jsxs(Styled.LabelWrapper, _Object$assign({
        "$noLabel": !label
      }, {
        children: [label && _jsxs(Styled.Label, {
          children: [label, mustInput && _jsx(Asterisk, {})]
        }), charLimit !== 0 && _jsx(CharLimit, {
          noLabel: !label,
          length: length,
          charLimit: charLimit
        })]
      })), description && _jsx(Styled.Description, {
        children: description
      })]
    }), _jsx(Styled.TextareaBorder, _Object$assign({
      "$isError": hasError,
      "$isExistsValue": !!inputValue,
      "$disabled": disabled
    }, {
      children: _jsx(Styled.Textarea, _Object$assign({
        ref: ref,
        value: inputValue,
        placeholder: placeholder,
        "$isError": hasError,
        "$hasScrollBar": hasScrollBar,
        "$disabled": disabled,
        readOnly: disabled,
        onChange: handleChange,
        onFocus: handleFocus,
        onBlur: handleBlur
      }, rest))
    })), hasFooterText && _jsx(HelperText, _Object$assign({
      color: hasError ? 'error' : 'gray',
      style: {
        marginLeft: '12px'
      }
    }, {
      children: hasError ? errorText : helperText
    }))]
  }));
});
export default Textarea;